package org.exoplatform.services.portletcontainer.test.portlet2;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;

import javax.portlet.*;

public class TestCache2 extends GenericPortlet {

  public void doView(RenderRequest request, RenderResponse response) throws PortletException, IOException {
    boolean istagvalid = request.getAttribute("istagvalid") != null;
    System.out.println("portlet2.TestCache2: ---- tag valid? : " + request.getAttribute("istagvalid"));
    request.setAttribute("istagvalid", "true");
    response.setContentType("text/html;charset=UTF-8");
    Date d = new Date();
    System.out.println("portlet2.TestCache2: ---- etag: " + request.getETag());
    if (request.getETag() != null && istagvalid) {
      response.getCacheControl().setExpirationTime(30);
      response.getCacheControl().setUseCachedContent(true);
      return;
    }
    response.getCacheControl().setExpirationTime(60);
    response.getCacheControl().setETag(request.getWindowId());
    response.setTitle("TestCache2: " + d.toString());

    PrintWriter w = response.getWriter();
    w.println("<h1>TestCache2: " + d.toString() + "</h1>");
    if (request.getParameter("invalidatetag") != null) {
      System.out.println("portlet2.TestCache2: ---- tag invalidated");
    }

    PortletURL actionURL = response.createActionURL();
    actionURL.setParameter("invalidatetag", "true");
    w.println("<p><a href=\"" + actionURL.toString() + "\">invalidate etag</a>");
  }

  public void processAction(ActionRequest actionRequest, ActionResponse actionResponse) throws PortletException, IOException {
    System.out.println("portlet2.TestCache2.processAction: ---- invalidatetag: " + actionRequest.getParameter("invalidatetag"));
    if (actionRequest.getParameter("invalidatetag") != null) {
      actionRequest.removeAttribute("istagvalid");
      actionResponse.setRenderParameter("invalidatetag", "true");
    }
  }  
  
}
