/**
 * Created by The eXo Platform SARL
 * Author : Alexey Zavizionov
 *          alexey.zavizionov@exoplatform.com.ua
 */
package org.exoplatform.services.portletcontainer.test.portlet2;

import javax.portlet.*;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Iterator;
import java.util.Map;

public class TestPublicParamPortlet3 extends GenericPortlet {

  protected void doView(RenderRequest renderRequest, RenderResponse renderResponse)
      throws PortletException, IOException {
    
    renderResponse.setContentType("text/html; charset=UTF-8");
    PrintWriter w = renderResponse.getWriter();

    w.println("<table width=\"100%\" border=\"1\">");
    w.println("<tr><th colspan=\"2\">Request PRIVATE parameters</th></tr>");
    w.println("<tr><th>parameter</th><th>value</th></tr>");
    Map params = renderRequest.getPrivateParameterMap();
    Iterator names = params.keySet().iterator();
    while (names.hasNext()) {
      String name = (String) names.next();
      w.println("<tr><td>" + name + "</td>");
      w.println("<td>" + renderRequest.getParameter(name) + "</td></tr>");
    }
    w.println("<tr><th colspan=\"2\">Request PUBLIC parameters</th></tr>");
    w.println("<tr><th>parameter</th><th>value</th></tr>");
    params = renderRequest.getPublicParameterMap();
    names = params.keySet().iterator();
    while (names.hasNext()) {
      String name = (String) names.next();
      w.println("<tr><td>" + name + "</td>");
      w.println("<td>" + renderRequest.getParameter(name) + "</td></tr>");
    }
    w.println("</table>");

    PortletURL url = renderResponse.createRenderURL();
    url.setParameter("public1", "-- from public3");
    url.setParameter("public2", "-- from public3");
    url.setParameter("private", "private...");
    url.setSecure(true);
    w.println("<p><a href=\"" + url.toString() + "\">set public param</a>");

  }

  public void processAction(ActionRequest actionRequest, ActionResponse actionResponse)
      throws PortletException, IOException {
  }
  
}
