/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

/**
 * Created by The eXo Platform SARL
 * Author : Mestrallet Benjamin
 *          benjmestrallet@users.sourceforge.net
 * Date: Jul 29, 2003
 * Time: 5:50:44 PM
 */
package org.exoplatform.services.portletcontainer.plugins.pc.portletAPIImp;


import javax.portlet.RenderRequest;
import javax.servlet.http.Cookie;

import org.exoplatform.Constants;
import java.util.*;
import org.exoplatform.services.portletcontainer.pci.RenderInput;

public class RenderRequestImp extends ClientDataRequestImp implements RenderRequest {

  private boolean isRenderRequest;
  private Map renderParameters;
	private Vector paramNames;
	private Map filteredMap;

  public RenderRequestImp(RequestContext reqCtx) {
    super(reqCtx);
    this.renderParameters = ((RenderInput) reqCtx.getInput()).getRenderParameters();
    //this.isUpdateCache = ((RenderInput) reqCtx.getInput()).isUpdateCache();
  }

  public String getParameter(String param) {
		if(param == null || param.startsWith(Constants.PARAMETER_ENCODER))
      throw new IllegalArgumentException("parameter must not be null");
    Object obj = renderParameters.get(param);
    if (obj instanceof String[]) {
      String[] tmp = (String[]) obj ;
      return tmp[0] ;
    }
    return (String) obj ;
  }

  public Enumeration getParameterNames() {
		if(paramNames == null){
			Set set = renderParameters.keySet();
			paramNames = new Vector();
    	for (Iterator iterator = set.iterator(); iterator.hasNext();) {
				String key = (String) iterator.next();
      	if(!key.startsWith(Constants.PARAMETER_ENCODER))
					paramNames.add(key);
			}
		}
    return paramNames.elements();
  }

  public String[] getParameterValues(String s) {
		if(s == null || s.startsWith(Constants.PARAMETER_ENCODER))
			throw new IllegalArgumentException("parameter must not be null");
		Object o = renderParameters.get(s);
		if (o == null)
		  return null;
		if (o instanceof String) {
		  String[] a = {(String)o};
      return a;
    }
    return (String[]) o;
  }

  public Map getParameterMap() {
		if(filteredMap == null){
			Set set = renderParameters.keySet();
			filteredMap = new HashMap();
    	for (Iterator iterator = set.iterator(); iterator.hasNext();) {
				String key = (String) iterator.next();
				Object values = renderParameters.get(key);
				if (values instanceof String) {
				  String[] a = {(String) values};
				  values = a;
				}
      	if(!key.startsWith(Constants.PARAMETER_ENCODER))
					filteredMap.put(key, values);
			}
		}
    return Collections.unmodifiableMap(filteredMap);
  }

  public String getETag() {
    return getProperty(RenderRequest.ETAG);
  }
  
  public String getLifecyclePhase() {
    return RENDER_PHASE;
  }
  
  @Override
  public Cookie[] getCookies() {
    // TODO Auto-generated method stub
    return super.getCookies();
  }

}
