package org.exoplatform.services.portletcontainer.imp.Portlet286;


import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.exoplatform.services.portletcontainer.PortletContainerException;
import org.exoplatform.services.portletcontainer.imp.EmptyResponse;
import org.exoplatform.services.portletcontainer.pci.ExoWindowID;
import org.exoplatform.services.portletcontainer.pci.RenderOutput;
import org.exoplatform.test.mocks.servlet.MockHttpSession;
import org.exoplatform.test.mocks.servlet.MockServletRequest;
import org.exoplatform.test.mocks.servlet.MockServletResponse;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

/**
 * Copyright 2001-2003 The eXo Platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

/**
 * Created by The eXo Platform SARL     
 * Author : Mestrallet Benjamin
 *          benjmestrallet@users.sourceforge.net
 * Date: 15 oct. 2003
 * Time: 20:51:01
 */
public class TestPortletURL extends BaseTest2{

	public TestPortletURL(String s) {
		super(s);
	}

	/**
	 * test (xxxiv) : A portlet cannot create a portlet URL using a window state that is not
	 *                supported by the portlet container. The setWindowState method must throw
	 *                a WindowStateException if that is the case.
	 *
	 * PLT.7.1.1
	 */
	public void testWindowStateSupport() throws PortletContainerException {
		HttpServletRequest request = new MockServletRequest(new MockHttpSession(), Locale.US, true);
		HttpServletResponse response = new MockServletResponse(new EmptyResponse());
		((ExoWindowID)renderInput.getWindowID()).setPortletName("PortletToTestStateSupport");
		RenderOutput o = portletContainer.render(request, response, renderInput);
		assertEquals("Exception occured", o.getTitle());
		assertEquals("javax.portlet.WindowStateException: The window state detached is not supported by that portlet",
						new String(o.getContent()));
	}

}
