/*
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */
package org.exoplatform.services.wsrp.producer.impl;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;
import org.exoplatform.services.portletcontainer.pci.WindowID;
import org.exoplatform.services.portletcontainer.pci.model.ExoPortletPreferences;
import org.exoplatform.services.portletcontainer.persistence.PortletPreferencesPersister;


/**
 * Created y the eXo platform team
 * User: Benjamin Mestrallet
 * Date: 8 juin 2004
 */
public class WSRPPortletPreferencesPersister implements PortletPreferencesPersister, Serializable {

  private static WSRPPortletPreferencesPersister ourInstance = new WSRPPortletPreferencesPersister();
  private Map prefs = new HashMap();
  private transient Log log;
  
  private WSRPPortletPreferencesPersister() {
    this.log = ExoLogger.getLogger(getClass()); 
  }  

  public static WSRPPortletPreferencesPersister getInstance() {
    return ourInstance;
  }

  public ExoPortletPreferences getPortletPreferences(WindowID windowID) throws Exception {
    return (ExoPortletPreferences) prefs.get(windowID.generateKey());
  }

  public void savePortletPreferences(WindowID windowID, 
                                     ExoPortletPreferences preferences) throws Exception {
    prefs.put(windowID.generateKey(), preferences);
  }
  
}