package org.exoplatform.services.wsrp.producer.impl.helpers;


import java.util.List;

import javax.portlet.PortletURL;
import javax.portlet.ResourceURL;

import org.exoplatform.services.portletcontainer.pci.PortletURLFactory;
import org.exoplatform.services.wsrp.producer.PersistentStateManager;

/**
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

/**
 * Created by the Exo Development team.
 * Author : Mestrallet Benjamin
 *          benjmestrallet@users.sourceforge.net
 * Date: 23 janv. 2004
 * Time: 18:20:54
 */
public class WSRPConsumerRewriterPortletURLFactory implements PortletURLFactory {
  private String markup;
  private String sessionID;
  private boolean isCurrentlySecured;
  private PersistentStateManager stateManager;
  private String portletHandle;
  private String template;
  private List supports;

  public WSRPConsumerRewriterPortletURLFactory(String markup,
                                               List supports,
                                               boolean isCurrentlySecured,
                                               String template, String portletHandle,
                                               PersistentStateManager stateManager,
                                               String sessionID) {
    this.markup = markup;
    this.supports = supports;
    this.isCurrentlySecured = isCurrentlySecured;
    this.template = template;
    this.portletHandle = portletHandle;
    this.stateManager = stateManager;
    this.sessionID = sessionID;
  }

  public PortletURL createPortletURL(String type) {
    return new ConsumerRewriterPortletURLImp(type, markup,
                                             supports, isCurrentlySecured,
                                             template, portletHandle,
                                             stateManager, sessionID);
  }
  
  public ResourceURL createResourceURL(String type) {
    return new ConsumerRewriterResourceURLImp(type, markup,
        supports, isCurrentlySecured,
        template, portletHandle,
        stateManager, sessionID);
  }
}
