package javax.portlet;


public class WindowStateException extends PortletException {

  private static final long serialVersionUID = 1L;

  private transient WindowState _state = null;

  public WindowStateException(String text, WindowState state) {
    super(text);
    _state = state;
  }

  public WindowStateException(String text, Throwable cause, WindowState state) {
    super(text, cause);
    _state = state;
  }

  public WindowStateException(Throwable cause, WindowState state) {
    super(cause);
    _state = state;
  }

  public WindowState getState() {
    return _state;
  }
}
